unit fGlForm;
interface
uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  Geometry, GLScene, GLObjects, GLGraph,
  GLMisc, GLTexture,{ AsyncTimer,}
  ExtCtrls, GLMesh, GLVectorFileObjects,
 { GLCollision,  GLSound, AsyncTimer,}
  GLCadencer,
  ComCtrls, StdCtrls, Gauges, jpeg, math,
{  fgrdfuncs,} Buttons, GLWin32Viewer;

Const
  StepSize = 1.0; {height grid steps to move with arrow key}
  RotAngle = 6; //angle to rotate with each key press

type
  TXYZGL = class(TForm)
    GLScene1: TGLScene;
    GLCamera1: TGLCamera;
    HeightField1: TGLHeightField;
    GLLightSource1: TGLLightSource;
    StatusBar1: TStatusBar;
    DummyCube1: TGLDummyCube;
    Panel1: TPanel;
    Viewmodegrp: TRadioGroup;
    VEedit: TEdit;
    Label1: TLabel;
    MtnsHelp: TBitBtn;
    ExitButton: TSpeedButton;
    HEdit: TEdit;
    Label2: TLabel;
    TextureEdit: TEdit;
    TextureLoader: TSpeedButton;
    Texture: TLabel;
    OpenDialog1: TOpenDialog;
    Label3: TLabel;
    Label4: TLabel;
    MinLabel: TLabel;
    MaxLabel: TLabel;
    CheckBox2: TCheckBox;
    ComboBox1: TComboBox;
    Label5: TLabel;
    CheckBox1: TCheckBox;
    GLSceneViewer1: TGLSceneViewer;
    Timer1: TTimer;
    procedure HeightField1GetHeight(const x, y: Single;
    var z: Single; var color: THomogeneousFltVector;
    var texPoint: TTexPoint);
    procedure FormCreate(Sender: TObject);
    procedure FormShowDown;
    procedure FormShow(Sender: TObject);
    procedure GLSceneViewer1MouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure GLSceneViewer1MouseMove(Sender: TObject;
      Shift: TShiftState; X, Y: Integer);
    procedure ViewmodegrpClick(Sender: TObject);
    procedure VEeditChange(Sender: TObject);
     procedure MtnsHelpClick(Sender: TObject);
    procedure ExitButtonClick(Sender: TObject);
    procedure TextureLoaderClick(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure HEditChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
{    grd:TGrd;}
    mx,my:integer;
  public
    { Public declarations }
    vertical_exaggeration:single;
    moving_altitude:single;
    ObserverHeight:Integer;
    procedure UpdateStatusBarPos;
    procedure UpdateStatusBarangle;
    procedure calcHeight;
    procedure HandleKeys;
  end;

var
  XYZGL: TXYZGL;

implementation

{$R *.DFM}
uses fUGlobal;

procedure TXYZGL.MtnsHelpClick(Sender: TObject);
begin
  Application.HelpContext(4567);
end;

procedure TXYZGL.ExitButtonClick(Sender: TObject);
begin
Hide;{Close;}
end;
procedure TXYZGL.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
Hide;
If isReallyGone then CanClose:=True else CanClose:=False;
end;
procedure TXYZGL.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  XYZGLX := XYZGL.left;
  XYZGLY := XYZGL.top;
{  DoSaver; save by main form...}
end;
procedure TXYZGL.FormCreate(Sender: TObject);
const maxbitmap = 1024;
begin
  top := XYZGLY;
  left := XYZGLX;
  vertical_exaggeration := 1.0;
  moving_altitude := 10; // height above landscape in fly mode
  DecimalSeparator:='.';
  ObserverHeight:=150;

   // no per-vertex coloring
   ComboBox1.ItemIndex:=0;
   viewmodegrp.itemindex := 0;
end;

procedure TXYZGL.FormShowDown;
var I:Integer;
begin

{MUST BE ODD number of data}
If ((FileSizeY mod 2)=0) then
{Resize it copy last to new 1}
begin
Setlength(ManMatrix,FileSizeX,FileSizeY+1);
for I:= 0 to FileSizeX-1 do
    ManMatrix[I,FileSizeY]:=ManMatrix[I,FileSizeY-1];
    inc(FileSizeY);
end;
If ((FileSizeX mod 2)=0) then
begin
{Resize it copy last to new 1}
Setlength(ManMatrix,FileSizeX+1,FileSizeY);
for I:= 0 to FileSizeY-1 do
    ManMatrix[FileSizeX,I]:=ManMatrix[FileSizeX-1,I];
    inc(FileSizeX);
end;

  MinLabel.Caption:=Inttostr(MinimumElevation);
  MaxLabel.Caption:=Inttostr(MaximumElevation);
{  grd := Tgrd.create;
  grd.loadfromfile('kapiti.grd');}
  viewmodegrp.enabled:=false;
  VEedit.enabled:=false;
  ComboBox1.enabled:=false;
  ComboBox1.ItemIndex:=0;  {Color}
  viewmodegrp.itemindex:=0;
  VEedit.text:='1.0';
  vertical_exaggeration:=1.0;
  ObserverHeight:=Round(0.77*FilesizeX);
  HEdit.text:=InttoStr(ObserverHeight);
  With Glcamera1 do
  begin
      TargetObject := nil;
      Position.X :=0;
      Position.Z :=4;
      direction.x := 1;
      direction.y := 0;
      direction.z := 0;
    end;


  HeightField1.YSamplingScale.Max := (FileSizeY{grd.height} div 2);
  HeightField1.YSamplingScale.Min := -1*(FileSizeY{grd.height} div 2);
  HeightField1.XSamplingScale.Max := (FileSizeX{grd.width }div 2);
  HeightField1.XSamplingScale.Min := -1*(FileSizeX{grd.width} div 2);

{Step
   if FOrigin<>FMin then begin
      Result:=(FOrigin-FMin)/FStep;
      if Result>=0 then
         Result:=Trunc(Result)
      else Result:=Trunc(Result)-1;
      Result:=FOrigin-FStep*Result;
   end else Result:=FMin;
}
// make texture fits     ... moved to texture file loader
{  heightfield1.Material.texture.Image.LoadFromFile('kapiti.jpg');
  heightfield1.material.texture.Disabled := false;}
  viewmodegrp.enabled:=True;
  VEedit.enabled:=True;
  ComboBox1.enabled:=True;
  calcheight; // adjust height of flight
  updatestatusbarpos;
  updatestatusbarangle;
end;

procedure TXYZGL.TextureLoaderClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'Texture (bmp)|*.bmp;*.jpg';
  OpenDialog1.Filename := TextureEdit.Text;
  OpenDialog1.InitialDir:=DemsDir;
  if (OpenDialog1.Execute) then
  begin
// make texture fits     ... moved to texture file loader
  heightfield1.Material.texture.Image.LoadFromFile(OpenDialog1.Filename);
  heightfield1.material.texture.Disabled := false;
  end;
end;

procedure TXYZGL.FormShow(Sender: TObject);
begin
  GLSceneViewer1.SetFocus;
end;



procedure TXYZGL.HeightField1GetHeight(const x, y: Single;
  var z: Single;
  var color: THomogeneousFltVector;
  var texPoint: TTexPoint);
{This assigns the heights from the grid in memory.}
var
  Heit : Single;
begin
{  Heit := ManMatrix[round(x ),round(y) ];}
  Heit := ManMatrix[round(x *(FileSizex-1)),
                     round((1-y) *(FileSizeY-1))];

{  Heit := ManMatrix[Trunc(x) + (FileSizeX div 2),
                    Trunc(y) + (FileSizeY div 2) ];}

(*  Heit := {grd.pts}ManMatrix[Trunc(y) + (FileSizeY{grd.Height} div 2),
                  Trunc(x) + (FileSizeX{grd.Width} div 2)];*)

  If heit = NullDemValue{grd.null} then
{    z := 0 else}
    z := ((MinimumElevation / CellSizeX)
          * vertical_exaggeration)
          else
    z := (Heit / CellSizeX{grd.cellsize})
          * vertical_exaggeration;
{The equation above is based on fact
that each x,y is a step on the grid and
in real terms, each step is cellsize metres wide}
{Overlay}
  with heightfield1 do
  begin
    texpoint.S := (x - XSamplingScale.min)/FileSizeX{grd.width};
    texpoint.T := (y - YSamplingScale.min)/FileSizeY{grd.height};
  end;
{Color.. according to Height... }
If z<1 then color:=clrBlue
  else If z< (MaximumElevation div 4)then
       VectorLerp(clrGreen, clrOlive, (z+1)/2, color)
  else VectorLerp(clrYellow, clrPurple, (z+1)/2, color);
end;

procedure TXYZGL.Timer1Timer(Sender: TObject);
begin
// only handle keys when in walk mode
 if viewmodegrp.itemindex=0 then
    HandleKeys;
end;

procedure TXYZGL.HandleKeys;
var
  poschanged:Boolean;

begin
  poschanged := false;
  if GetAsyncKeyState(VK_UP)<0 then
    begin
      GLCamera1.Move(StepSize);
      poschanged := true;
    end;

  if GetAsyncKeyState(VK_DOWN)<0 then
    begin
      GLCamera1.Move(-StepSize);
      poschanged := true;
    end;

  if GetAsyncKeyState(VK_LEFT)<0 then
    begin
      if GetAsyncKeyState(VK_MENU)<0 then
      begin
        GLCamera1.Slide(-StepSize);
       poschanged := true;
      end  else
      begin
        GLCamera1.Turn(-RotAngle);
        updatestatusbarangle;
      end;
    end;

  if GetAsyncKeyState(VK_RIGHT)<0 then
    begin
      if GetAsyncKeyState(VK_MENU)<0 then
      begin
        GLCamera1.Slide(StepSize);
        poschanged := true;
      end  else
      begin
        GLCamera1.Turn(RotAngle);
        updatestatusbarangle;
      end;
  end;
  If poschanged then
  begin
    calcheight; // adjust fly height so it above the surface
    updatestatusbarpos;
  end;
end;


procedure TXYZGL.UpdateStatusBarpos;
begin
// shows camera position in real world units
  Statusbar1.Panels[0].Text :=
  format('X = %f',[DemiLeftX1e{grd.OriginX} +
  ((FileSizeX{grd.width} div 2)
  - GLCamera1.Position.z)*CellSizeX{grd.cellsize}]);
  Statusbar1.Panels[1].Text :=
  format('Y = %f',[DemiTopY1e{grd.OriginY} +
   ((FileSizeY{grd.height} div 2)
   - GLCamera1.Position.x)*CellSizeY{grd.cellsize}]);
  Statusbar1.Panels[2].Text :=
  format('Z = %f',[(GLCamera1.Position.y - moving_altitude)
                    /vertical_exaggeration
                    *CellSizeX{grd.cellsize}]);
end;

procedure TXYZGL.UpdateStatusBarangle;
var angle:single;
  x,z:single;
begin
// shows camera direction in normal compass heading
 x := glcamera1.Direction.x;
 z := glcamera1.Direction.z;
 angle := (arctan(Z/X) * 180 /pi);
 If (x>0) then angle := 180 + angle;
 if (x<0) and (z>0) then angle := 360 + angle;
 Statusbar1.Panels[3].text := format('Heading = %f',[angle]);
end;

procedure TXYZGL.calcHeight;
// Adjusts camera height so it is above the landscape
Var
  Height: Single;
  X, Z : Integer;
begin
    X := Trunc(GLCamera1.Position.X); // Left
    Z := Trunc(GLCamera1.Position.Z); // Front to Back
    If ((X< (FileSizeX div 2)) and (X> (-FileSizeX div 2))
     and (Z < (FileSizeY div 2)) and (Z > (-FileSizeY div 2))) then
{REDO to just Backstep  GLCamera1.Position.X
or GLCamera1.Position.Z
      GLCamera1.Move(-StepSize);Down
      GLCamera1.Move(StepSize);UP

        GLCamera1.Turn(RotAngle);Right
        GLCamera1.Turn(-RotAngle);Left

    calcheight; // adjust fly height so it above the surface
    updatestatusbarpos;
      }
 begin

    Height := ManMatrix[x + (FileSizeX div 2),
                        z + (FileSizeY div 2)    ];
(*    Height := {grd.pts}ManMatrix[z + (FileSizeY{grd.height} div 2),
                      x + (FileSizeX{grd.Width} div 2)];*)
    If height = NullDemValue{grd.null} then
{      height := 0;}
      height :=MinimumElevation;

    GLCamera1.Position.Y := (Height / CellSizeY {grd.cellsize})
                            * vertical_exaggeration
                            + moving_altitude;
 end;

end;

procedure TXYZGL.GLSceneViewer1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
   mx:=x; my:=y;
end;

procedure TXYZGL.GLSceneViewer1MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  if (Shift<>[]) and (viewmodegrp.itemindex=1) then begin
      TGLSceneViewer(Sender).Camera.MoveAroundTarget(my-y, mx-x);
      my:=y; mx:=x;
   end;
end;

procedure TXYZGL.ViewmodegrpClick(Sender: TObject);
{switch between fly through and examine modes}
var ve:single;
    code:Integer;
begin
  With Glcamera1 do
  begin
    If viewmodegrp.itemindex = 0 then
    begin
      VEedit.enabled:=true;
      HEdit.enabled:=true;
  Val(VEedit.text,ve,code);
  If (code=0) and (ve>0.0) then vertical_exaggeration := ve;
      TargetObject := nil;
      Position.X :=0;
      Position.Z :=4;
      direction.x := 1;
      direction.y := 0;
      direction.z := 0;
      calcheight;
    end else
    begin
      VEedit.enabled:=false;
      HEdit.enabled:=false;
      TargetObject := dummycube1;
      position.y := ObserverHeight;{ 0.77*FilesizeX; }{150;}
    end;
  end;
  glsceneviewer1.SetFocus;
end;

procedure TXYZGL.VEeditChange(Sender: TObject);
// change the vertical exaggeration
var ve:single;
    code:Integer;
begin
  If viewmodegrp.itemindex = 0 then
  begin
  Val(VEedit.text,ve,code);
  If (code=0) and (ve>0.0) then
  begin
    vertical_exaggeration := ve;
    heightfield1.StructureChanged;
    {force getheightfield to be called again}
    glsceneviewer1.SetFocus;
  end;
  end;
end;


procedure TXYZGL.HEditChange(Sender: TObject);
// change the vertical Height of Observer
var oh:Integer;
    code:Integer;
begin
    If viewmodegrp.itemindex = 0 then
  begin
  Val(HEdit.text,oh,code);
  If (code=0) and (oh>0) then
    begin
    ObserverHeight := oh;
{    Glcamera1.position.y := ObserverHeight;}
    end;
{  glsceneviewer1.SetFocus;}
  end;
end;




procedure TXYZGL.CheckBox2Click(Sender: TObject);
begin
   GLLightSource1.Shining:=CheckBox2.Checked;
end;

procedure TXYZGL.ComboBox1Change(Sender: TObject);
begin
   // change per vertex color mode
   case ComboBox1.ItemIndex of
      0 : HeightField1.ColorMode:=hfcmNone;
      1 : HeightField1.ColorMode:=hfcmEmission;
      2 : HeightField1.ColorMode:=hfcmAmbient;
      3 : HeightField1.ColorMode:=hfcmDiffuse;
      4 : HeightField1.ColorMode:=hfcmAmbientAndDiffuse;
   end;
{   THeightFieldColorMode =
   (hfcmNone, hfcmEmission, hfcmAmbient, hfcmDiffuse,
                            hfcmAmbientAndDiffuse);}
end;

procedure TXYZGL.CheckBox1Click(Sender: TObject);
begin
   // enable two sided surface
   if CheckBox1.Checked then
   HeightField1.Options:=HeightField1.Options+[hfoTwoSided]
   else HeightField1.Options:=HeightField1.Options-[hfoTwoSided];
end;


(*
procedure TXYZGL.HeightField1GetHeight(const x, y: Single;
  var z: Single;
  var color: THomogeneousFltVector;
  var texPoint: TTexPoint);
{This assigns the heights from the grid in memory.}
var
  Heit : Single;
begin
{  Heit := ManMatrix[round(x ),round(y) ];}
{  Heit := ManMatrix[round(x *(FileSizex-1)),round((1-y) *(FileSizeY-1))];}

  Heit := ManMatrix[Trunc(x) + (FileSizeX div 2),
                    Trunc(y) + (FileSizeY div 2) ];

  Heit := {grd.pts}ManMatrix[Trunc(y) + (FileSizeY{grd.Height} div 2),
                  Trunc(x) + (FileSizeX{grd.Width} div 2)];

  If heit = NullDemValue{grd.null} then
{    z := 0 else}
    z := ((MinimumElevation / CellSizeX)
          * vertical_exaggeration)
          else
    z := (Heit / CellSizeX{grd.cellsize})
          * vertical_exaggeration;
{The equation above is based on fact
that each x,y is a step on the grid and
in real terms, each step is cellsize metres wide}
{Overlay}
  with heightfield1 do
  begin
    texpoint.S := (x - XSamplingScale.min)/FileSizeX{grd.width};
    texpoint.T := (y - YSamplingScale.min)/FileSizeY{grd.height};
  end;
{Color.. according to Height... }
If z<1 then color:=clrBlue
  else If z< (MaximumElevation div 4)then
       VectorLerp(clrGreen, clrOlive, (z+1)/2, color)
  else VectorLerp(clrYellow, clrPurple, (z+1)/2, color);
end;
*)





end.
